unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Memo2: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TVectorClass = class
  private
    FVector : array [1..10] of Word;
  protected
    function GetVector (Index : Integer) : Word;
    procedure SetVector (Index : Integer; Value : Word);
    procedure AddToVectorElem (Index : Integer; Value : Word);
  public
    property Elements [Index : Integer] : Word
        read GetVector
        write SetVector;    default; {    }
    property AddToElement [Index : Integer] : Word
        write AddToVectorElem;
  end;


var
  Form1: TForm1;
  MyVector : TVectorClass;

implementation

{$R *.dfm}

function TVectorClass.GetVector(Index : Integer) : Word;
begin
  Result := FVector [Index];
end;

procedure TVectorClass.SetVector (Index : Integer; Value : Word);
begin
  FVector [Index] := Value;
end;

procedure TVectorClass.AddToVectorElem(Index : Integer; Value : Word);
begin
  FVector [Index] := FVector [Index] + Value;
end;


procedure TForm1.FormCreate(Sender: TObject);
var
  i : Integer;
  S : String;
begin
  MyVector := TVectorClass.Create;
  for i := 1 to 10 do
    MyVector[i] := i; {   Elements   }
    {,       }
  for i := 1 to 10 do
  begin
    Str(MyVector.Elements[i], S);
    Form1.Memo1.Lines.Add(S);
  end;
  for i := 1 to 10 do
    MyVector.AddToElement[i] := 5;  {   }
    { AddToElement      }
  for i := 1 to 10 do
  begin
    Str (MyVector[i], S);
    Form1.Memo2.Lines.Add(S);
  end;
  MyVector.Free;
end;

end.
